<?php
$xml = array();

function smarty_t($params, $string, &$smarty) {
   foreach($params as $key => $value) {
      $params["%$key"] = $value;
      unset($params[$key]);
   }
   print(t($string, $params));

}

function t($string, $args = array()) {
   global $xml;
	 $lang=$_GET['lang'];
	 if ($lang=="")
	 		$lang="en";

	 $filename=$_SERVER['DOCUMENT_ROOT']."/../locale/".$lang.".xml";
   if(empty($xml)) {
      if(file_exists($filename)) {
         $xml = getXmlTree($filename);
      } else {
         return strtr($string, $args);
      }
   }

   foreach($xml[0]['children'] as $tag) {
      if($tag['tag'] == "MESSAGE") {
         if($tag['children'][0]['value'] == $string) {
            if($tag['children'][1]['value'] != "") {
               return strtr($tag['children'][1]['value'], $args);
            }
         }
      }
   }

   return strtr($string, $args);
}

function getChildren($vals, &$i) { 
   $children = array(); 
   
   if(!isset($vals[$i]['attributes'])) {
      $vals[$i]['attributes'] = "";
   }
   
   while(++$i < count($vals)) {
      if(!isset($vals[$i]['attributes'])) {
         $vals[$i]['attributes'] = "";
      }

      if(!isset($vals[$i]['value'])) {
         $vals[$i]['value'] = "";
      }

      switch ($vals[$i]['type']) {
      case 'complete':
         array_push($children, array('tag' => $vals[$i]['tag'], 'attributes' => $vals[$i]['attributes'], 'value' => $vals[$i]['value']));
         break;
      case 'open':
         array_push($children, array('tag' => $vals[$i]['tag'], 'attributes' => $vals[$i]['attributes'], 'children' => getChildren($vals, $i)));
         break;
      case 'close':
         return $children;
         break;
      }
   }

   return $children;
}

function getXmlTree($file) { 
   $data = implode("", file($file));
   $xml  = xml_parser_create();
   xml_parser_set_option($xml, XML_OPTION_SKIP_WHITE, 1);
   xml_parse_into_struct($xml, $data, &$vals, &$index);
   xml_parser_free($xml);

   $tree = array();
   $i = 0;
   array_push($tree, array('tag' => $vals[$i]['tag'], 'attributes' => $vals[$i]['attributes'], 'children' => getChildren($vals, $i)));

   return $tree;
}
?>
